from delta_sharing.protocol import Schema, Share
from delta_sharing.rest_client import DeltaSharingProfile
from pathlib import Path
from typing import BinaryIO, TextIO
from ydata.connectors.base_connector import BaseConnector
from ydata.dataset import Dataset

def manage_exceptions(func): ...

class DatabricksUnityCatalog(BaseConnector):
    def __init__(self, profile: str | BinaryIO | TextIO | Path | DeltaSharingProfile) -> None: ...
    @property
    def client(self): ...
    def set_client(self) -> None: ...
    def list_shares(self) -> list: ...
    def list_schemas(self, share_name: str | Share) -> list: ...
    def list_tables(self, share_name: str | Share, schema_name: str | Schema) -> list: ...
    def list_all_tables(self) -> dict: ...
    def read_table_sample(self, share_name: str, schema_name: str, table_name: str, sample_size: int = 100) -> Dataset: ...
    def read_table(self, share_name: str, schema_name: str, table_name: str, sample_size: int | None = None) -> Dataset: ...
    def test(self) -> None: ...
