import abc
from abc import abstractmethod
from ydata.connectors.base_connector import BaseConnector
from ydata.connectors.filetype import FileType
from ydata.dataset import Dataset

class ObjectStorageConnector(BaseConnector, metaclass=abc.ABCMeta):
    def __init__(self) -> None: ...
    @abstractmethod
    def parse_connector_url(self, url: str): ...
    @abstractmethod
    def get_file_paths(self, path: str, file_type: FileType, extension: str): ...
    @property
    def filesystem(self) -> None: ...
    @property
    def client(self): ...
    @abstractmethod
    def set_client(self): ...
    def read_file(self, path: str, file_type: FileType = ..., sample_size: int | None = None, sep: str = ',', has_header: bool = True, columns: list[str] | None = None, schema: dict | None = None, *args, **kwargs) -> Dataset: ...
    def read_sample(self, path: str, file_type: FileType = ..., sample_size: int = ..., sep: str = ',', *args, **kwargs) -> Dataset: ...
    def write_file(self, data, path: str, file_type: FileType | None = None, *args, **kwargs): ...
    @abstractmethod
    def test(self): ...
