from ydata.constraints.base import Constraint
from ydata.dataset.dataset import Dataset

class ConstraintEngine:
    def __init__(self, constraints: list[Constraint] | None = None) -> None: ...
    def add_constraint(self, constraint: Constraint) -> None: ...
    def add_constraints(self, constraints: list[Constraint]) -> None: ...
    def validate(self, dataset: Dataset) -> None: ...
    def violated_constraints(self, constraint: Constraint | str) -> dict: ...
    def violated_rows(self, constraint: Constraint | str) -> dict: ...
    def violated_columns(self, constraint: Constraint | str) -> dict: ...
    def summary(self, include_rows: bool = False) -> dict: ...
    def explain_constraints(self) -> dict[str, str]: ...
